// order of + and * avealuation check
#include <iostream>
#include <vector>
#include <memory>
#include <algorithm>
using namespace std;

struct Thing {
  int val;
  explicit Thing(int i) : val(i) {}
  Thing(Thing&&o) : val(o.val) {}
  Thing& operator=(Thing&&o)  { val=o.val; return *this; }
private:
  explicit Thing(); //no
};

int main() {
  cerr << "=== " << __FILE__ << " ===" << endl;
 
  vector<Thing> vs;
  vs.push_back( Thing(12) );

  typedef unique_ptr<Thing> PThing;
  vector<PThing> ws;
  ws.push_back( PThing(new Thing(22)) );

  PThing &x = ws.back();
  cerr << "is it 22? " << x->val << std::endl;

  vector<PThing> xs;
  swap(xs, ws);

  cerr << "still 22? " << x->val << std::endl;
 
  cerr << " ws.size should be 0: " << ws.size() << endl;
  cerr << " xs.size should be 1: " << xs.size() << endl;
  xs.pop_back(); // now also 0.
  // x is now invalid.


  unique_ptr<int[]> iarr( new int[3] );
  iarr[0] = 30;
  iarr[1] = 31;
  iarr[2] = 32;
  cerr << "31 ? " << iarr[1] << endl;

  return EXIT_SUCCESS;
}
//- eof
