// async check. GCC 4.5.0 does not compile this for now.
#define _GLIBCXX_USE_NANOSLEEP // sleep_for()
#include <iostream>
#include <thread>  // sleep
#include <chrono>  // millisecs
#include <future>  //! async
using namespace std;
using namespace chrono;

void do_stuff(int id, int loops, int pause_ms) {
    for(int i = 0; i<loops; ++i) {
      cerr << id;
      this_thread::sleep_for(milliseconds(pause_ms));
    }
}

struct Calculate_the_answer_to_LtUaE {
  typedef int result_type;
  int operator()() const {
    do_stuff(2, 200, 50);
    return 42;
  }
};

void check1()
{
  auto the_answer = async( Calculate_the_answer_to_LtUaE() );
  do_stuff(1, 150, 80);
  cerr << endl
       << "The answer to life, the universe and everything is "
       << the_answer.get() << endl;
}

//////////////////////////////////////////////////////////////////////

int main() {
  std::cerr << "=== " << __FILE__ << " ===" << std::endl;

  try {

    check1();

  } catch(system_error &e) {
    cerr << "ERROR '" << e.what() <<"'"<< endl;
    return EXIT_FAILURE;
  } catch(...) {
    cerr << "ERROR unknown" << endl;
    return EXIT_FAILURE;
  }
  
  return EXIT_SUCCESS;
}

//- eof
